function [] = plotFigureSDCv2(sigmasTCS, sigmasSP)
%%%%%%%%%%%%%%%%%
% warning('This graph is being padded with extra data.')
% sigmasTCS = [sigmasTCS mean(mean(sigmasTCS)) + .5 + randn(5,3) * sqrt(1)];
% sigmasSP = [sigmasSP mean(mean(sigmasSP)) + randn(5,6)*sqrt(.5)];
%%%%%%%%%%%%%%%%%

figure
hold on

stateIndices = [1  5  3];

% States 1 3 5 are long walk, follow obstacle and follow obstacle sin.
% stdData = [std(sigmasTCS(stateIndices, :)')' std(sigmasSP(stateIndices, :)')'];


% reshape the data to fit six boxplots (so we need six columns)
data = [{sigmasTCS(1,:)'} {sigmasSP(1,:)'}  {sigmasTCS([5],:)'}  {sigmasSP([5],:)'} {sigmasTCS([3],:)'} {sigmasSP([3],:)'}];  % TODO:  Ugly code

positionsOfBoxes = [1 2 3 4 5 6];
patchColors = [1 1 1; .75 .75 .75];
for ctr = 1:size(data,2)
    % Make sure to multiply data by 2.54 to convert inches to centimeter
    [outliers,hh] = boxutilLL(data{ctr}(:) * 2.54,1,positionsOfBoxes(ctr),.5, ...
                           '','r+',1,1.5,0, patchColors(mod(ctr,2)+1,:));  % Note:  I had to step through boxplot.m to get some of these values. --LTL                   
%     plot(positionsOfBoxes(ctr)*ones(1,size(data{ctr}(:))),data{ctr}(:)*2.54, 'ro')
    median(data{ctr}(:)) * 2.54
end



% Label the x axis properly.
textLabels = {sprintf('Feedback-\nControlled');sprintf('Self-\nPropelled'); ...
    sprintf('Feedback-\nControlled');sprintf('Self-\nPropelled'); ...
    sprintf('Feedback-\nControlled');sprintf('Self-\nPropelled')  };
% Note that the center of each group of bars are at the values 1:3
for j = 1:length(textLabels)
    textHandle(j) = text(positionsOfBoxes(j),-.05,textLabels(j));
    set(textHandle(j),'Clipping', 'off')
    set(textHandle(j),'HorizontalAlignment','center')
    set(textHandle(j),'VerticalAlignment','top')
    set(textHandle(j),'FontSize',18)
end

% Attempt Group Labels
groupLabels = {sprintf('Constant\nSpeed');sprintf('Continuous\nChanges');sprintf('Abrupt\nChanges')};

% Put in group labels
for j = 1:length(groupLabels)
    positionOfGroupLabel = mean([positionsOfBoxes(2*j) positionsOfBoxes(2*j-1)]);
    textHandle(j) = text(positionOfGroupLabel,-3.8,groupLabels(j));
    set(textHandle(j),'Clipping', 'off')
    set(textHandle(j),'HorizontalAlignment','center')
    set(textHandle(j),'VerticalAlignment','top')
    set(textHandle(j),'FontSize',22)
end
    
    
% Calculate which are statistically significant
stateGroups = [{1}  {[5]} {[3]}];
for i = 1:3 % three for each of the three states
    
   data1 = sigmasTCS(stateGroups{i}, :);
   data2 = sigmasSP(stateGroups{i}, :);
   [p h stats] = signrank(data1(:),data2(:));
   signif(i) = h;
   disp(['p = ' num2str(p) ' stat = ' num2str(stats.signedrank) ' n = ' num2str(length(data1(:))) ])
   % If there is a significant difference, put a star over the bar.
   % Removed since all were stat signif.
   if (h == 1)
       text(mean([positionsOfBoxes(2*i) positionsOfBoxes(2*i-1)]), 2.54*max(max(data1(:)), max(data2(:)))+ .5, '*','FontSize',28)
   end
end

signrank(sigmasTCS(3, :),sigmasTCS(5, :))
signrank(sigmasSP(3, :),sigmasSP(5, :))

hold on;

% Create dividing lines
xPosition = mean([positionsOfBoxes(2) positionsOfBoxes(3)]);
line([xPosition xPosition], [0 45], 'Color', 'k', 'LineStyle', ':','LineWidth', 1)

xPosition = mean([positionsOfBoxes(4) positionsOfBoxes(5)]);
line([xPosition xPosition], [0 45], 'Color', 'k', 'LineStyle', ':','LineWidth', 1)


%set(gca,'XTickLabel', { 'Constant Speed';'Constant Speed with Abrupt Changes' ; 'Never Constant'  }  )
set(gca,'XTickLabel', { '';'' ; '' ;'';'' ; ''  },'XColor', [1 1 1] )
set(gca,'FontSize', 20)
%legend('Feedback Controlled','Self-Propelled','Location','NorthWest')
ylabel(sprintf('Position Error Range (cm)'), 'FontSize',36)
%ylim([0 45])
xlim([.5 6.5])

% Adjust the Outer Position to make sure that x-axis text does not get
% clipped.
%set(gca, 'ActivePositionProperty', 'position')
outerPosition = get(gca, 'OuterPosition');
set(gca, 'OuterPosition', outerPosition + [-.05 .04 0 0]);


